<?php  	
/**
 * @package DavidmirvmirvDashboard controller
 * @desc  Controls all actions for the backing up databases
 * @author David M. Sielert
 * @desc 7-17-2009
 */
defined("C5_EXECUTE") or die(_("Access Denied."));

Class DashboardDavidmirvDbBackupController Extends Controller {
   public function on_start() {
      $this->token = Loader::helper('validation/token');
      $subnav = array(
         array(View::url('/dashboard/davidmirv_db_backup'), 'Run/View Backups',true),
         array(View::url('/dashboard/davidmirv_db_backup/help'),'Help', $prefsSelected)
      );
      $this->set('subnav', $subnav);
   } 
	/**
	 * runBackup  
	 * 
	 * @access public
	 * @return void
	 */
	public function runBackup($encrypt = false) {
      $encrypt = (bool)$encrypt;
      Loader::Library('davidmirv_db_backup_complete','davidmirv_db_backup');
      $backup = new DavidmirvDbBackupComplete($encrypt);   
      $this->view();
	}
   /*
    * NO Package job support in C5 Yet...
   public function addJob() {
      Loader::Model('package');
      $pkgs = PackageList::get(1);
      //print_r($pkgs);
   }
   public function RemoveJob() {\
   }

    */
	/**
	 * view  
	 * 
	 * @access public
	 * @return void
	 */
	public function view() {	
		if(is_dir(DIR_BASE . "/files/dbbackups")) {
				  $dh_bd = opendir(DIR_BASE . '/files/dbbackups');
				  while ( ($file = readdir($dh_bd)) != false ) {
                 if ($file != "." && $file != ".." && $file != ".htaccess" ){
                    $arr_bckups[] = $file;
                 }
				  }
      } 
      $arr_backupfileinfo = Array();
      if (count($arr_bckups) > 0) {
         foreach ($arr_bckups as $bkupfile) {
            preg_match('/[0-9]+/',$bkupfile,$timestamp);
            $arr_backupfileinfo[] = Array("file" => $bkupfile,  "date" =>  date("n-j-Y H:i",$timestamp[0]));
         }
         $this->set('backups',$arr_backupfileinfo);
      }
			  
	}
   
      /**
       * delete_backup 
       * @desc Deletes backup files from the file system
       * @param string $str_fname Filename to be deleted
       * @access public
       * @return void
       */
   public   function delete_backup($str_fname) {
      //For Security reasons...  allow only known characters in the string e.g no / \ so you can't exploit this
      $int_mResult = preg_match('/[0-9A-Za-z._]+/',$str_fname,$ar_matches);
      $str_fname = $ar_matches[0];
      if (!is_null($str_fname) && trim($str_fname) != "" && !preg_match('/\.\./',$str_fname) && file_exists(DIR_BASE . "/files/dbbackups/$str_fname")) {
         chmod(DIR_BASE . "/files/dbbackups/$str_fname",666);
         unlink(DIR_BASE . "/files/dbbackups/$str_fname");
      }
      $this->view();
   }

   public function restore_backup($file) {
      Loader::Model('davidmirvcrypt','davidmirv_db_backup');
      $db = Loader::db(); 
      chmod(DIR_BASE . '/files/dbbackups/'. $file, 0666);
      $str_restSql =      file_get_contents(DIR_BASE . '/files/dbbackups/' . $file);
      if ( !preg_match('/INSERT/m',$str_restSql) && !preg_match('/CREATE/m',$str_restSql) ) {
	  	 $crypt = new DavidmirvCryptModel();
         $str_restSql = $crypt->decrypt($str_restSql);
      }
      $arr_sqlStmts = explode("\n\n",$str_restSql);

    //  print_r($arr_sqlStmts);
     // print "----------------------------";
      foreach ($arr_sqlStmts as $str_stmt) {
         if (trim($str_stmt) != "") { 
            $res_restoration = $db->execute($str_stmt);
            if (!$res_restoration) { 
               $this->set("error",array("There was an error trying to restore the database. In query $str_stmt"));
               return;
            }
       //     print $str_stmt;
         }

      }
      $this->set("message","Restoration Sucessful");

     //reset perms for security! 
      chmod(DIR_BASE . '/files/dbbackups/'. $file, 0666);
	  
	  Cache::flush();
	  
      $this->view();
   }
      
	/**
	 * __construct  
	 * 
	 * @access public
	 * @return void
	 *a*/
	public function __construct() {
      $ht = Loader::helper('html');
      $this->addHeaderItem($ht->javascript('jquery.cookie.js','davidmirv_db_backup'));
	}
}

?>
